require "import"
import "android.content.*"

local selectedText = this.getText(node)
local links = {}

-- Extract all links from the selected text
for link in selectedText:gmatch("https?://%S+") do
    table.insert(links, link)
end

if #links > 0 then
    local linkText = table.concat(links, "\n")  -- Combine links into a single string with line breaks

    -- Count the number of links
    local linkCount = #links
    local formattedLinkCount = string.format("%d", linkCount):reverse():gsub("(%d%d%d)", "%1,"):reverse():gsub("^,", "")
    local linkCounterText = "Number of Links: " .. formattedLinkCount .. ".\n\n" .. linkText

    local intent = Intent(Intent.ACTION_SEND)
    intent.type = "text/plain"
    intent.putExtra(Intent.EXTRA_TEXT, linkCounterText)

    -- Clear existing flags to allow multiple apps to appear in the chooser
    intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
    intent.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)

    this.startActivity(Intent.createChooser(intent, "Share link using"))
else
    this.showToast("No link to share.")
end